package org.netkernel.lang.dpml.endpoint;

import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.INKFResponseReadOnly;
import org.netkernel.layer0.nkf.NKFException;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;

public class ThrowAccessor extends StandardAccessorImpl
{
	public ThrowAccessor()
	{	declareThreadSafe();
		declareUnhandledExceptionsExpired(false);
	}
	
	public void onSource(INKFRequestContext aContext) throws Exception
	{
		String id=aContext.source("arg:id",String.class);
		String message=null;
		if (aContext.getThisRequest().argumentExists("message"))
		{	message=aContext.source("arg:message",String.class);
		}
		Throwable cause=null;
		if (aContext.getThisRequest().argumentExists("cause"))
		{	try
			{	aContext.sourceForResponse("arg:cause",Exception.class);
			}
			catch (NKFException e)
			{	cause=e.getCause();
			}
		}
		NKFException result= new NKFException(id,message,cause);
		aContext.createResponseFrom(result);
		
	}		
}
