package org.netkernel.lang.dpml.representation;

import org.netkernel.lang.dpml.ast.IScope;
import org.netkernel.lang.dpml.ast.IVariable;
import org.netkernel.lang.dpml.endpoint.DPMLScriptContext;
import org.netkernel.urii.ISpace;

import java.util.Collections;
import java.util.Map;

public class DPMLRepresentation
{
	private final IScope mScope;
	private final Map mVariables;
	private final DPMLScriptContext mScriptContext;
	
	public DPMLRepresentation(IScope aScope, Map aVariablesById, ISpace aDPMLContext, String aCWU)
	{	mScope=aScope;
		mVariables = aVariablesById;
		mScriptContext=new DPMLScriptContext(this,aDPMLContext,aCWU);
	}

public IScope getRootScope()
	{	return mScope;
	}
	
	public IVariable resolveId(String aId)
	{	return (IVariable)mVariables.get(aId);
	}
	
	public DPMLScriptContext getScriptContext()
	{	return mScriptContext;
	}
	
	public Map getVariablesById()
	{	return Collections.unmodifiableMap(mVariables);
	}
}
